using System;
using System.Collections.Generic;
using System.Runtime.Serialization;

namespace Sample2
{
	public interface IDic<TKey, TValue>
	{
		IEqualityComparer<TKey> Comparer { get; }
		int Count { get; }
		Dictionary<TKey, TValue>.KeyCollection Keys { get; }
		Dictionary<TKey, TValue>.ValueCollection Values { get; }
		TValue this[TKey key]{ get; set; }
		
		
		void Add(TKey key, TValue value);
		void Clear();
		bool ContainsKey(TKey key);
		bool ContainsValue(TValue value);
		Dictionary<TKey, TValue>.Enumerator GetEnumerator();
		void GetObjectData(SerializationInfo info, StreamingContext context);
		void OnDeserialization(object sender);
		bool Remove(TKey key);
		bool TryGetValue(TKey key, out TValue value);
	}
}