﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Reflection;

using aDictionaryExtension;
using aSourceBuilder;
using aMultipleInheritanceHelpler;

namespace aMultipleInheritance
{
	public partial class zMultipleInheritance
	{
		/// <summary>
		/// memberをmemberMapで修正したものをActionで実行させる
		/// </summary>
		static void WriteMember(string name, zMemberData member, MemberInfo infoN, zMemberMap memberMap,
			string[] paramNames, zSourceBuilder b, Action<zMemberData> writeAction)
		{
			var func = memberMap.GetValueN(name);
			if (func != null)
			{
				member = func(member);
			}

			if (member.IsUsed == false)
			{
				return;
			}

			b.Line("");
			try
			{
				b.Add(zMultipleInheritanceHelper.BeforeMemberString(
					member.CommentData, member.Attributes, infoN, paramNames, b));
			}
			catch (zBeforeMemberString_NumParamsException e)
			{
				e.yRealNumParams = paramNames.Length;
				e.yWroteNumParam = member.CommentData.Params.Length;
				e.yMemberName = name;

				throw e;
			}
			writeAction(member);
		}

	}
}
