using System;
using System.Collections.Generic;
using System.Runtime.Serialization;

namespace aMultipleInheritance
{
	public class Test
	{
		private Dictionary<string, int> dic;
		
		public Test(Dictionary<string, int> dic)
		{
			this.dic = dic;
		}
		
		
		public IEqualityComparer<string> Comparer
		{
			get{ return dic.Comparer; }
		}
		
		public int Count
		{
			get{ return dic.Count; }
		}
		
		public Dictionary<string, int>.KeyCollection Keys
		{
			get{ return dic.Keys; }
		}
		
		public Dictionary<string, int>.ValueCollection Values
		{
			get{ return dic.Values; }
		}
		
		public int this[string key]
		{
			get{ return dic[key]; }
			set{ dic[key] = value; }
		}
		
		public void Add(string key, int value)
		{
			dic.Add(key, value);
		}
		
		public void Clear()
		{
			dic.Clear();
		}
		
		public bool ContainsKey(string key)
		{
			return dic.ContainsKey(key);
		}
		
		public bool ContainsValue(int value)
		{
			return dic.ContainsValue(value);
		}
		
		public Dictionary<string, int>.Enumerator GetEnumerator()
		{
			return dic.GetEnumerator();
		}
		
		public void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			dic.GetObjectData(info, context);
		}
		
		public void OnDeserialization(object sender)
		{
			dic.OnDeserialization(sender);
		}
		
		public bool Remove(string key)
		{
			return dic.Remove(key);
		}
		
		public bool TryGetValue(string key, out int value)
		{
			return dic.TryGetValue(key, out value);
		}
	}
}