﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace aDictionaryExtension
{
	public static class zDictionaryExtension
	{
		public static TValue GetValueN<TKey, TValue>(this IDictionary<TKey, TValue> dict, TKey key)
		{
			TValue value;

			if (dict.TryGetValue(key, out value))
				return value;

			return default(TValue);
		}
	}
}
