﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace aMultipleInheritance
{
	/// <summary>
	/// コメントの設定
	/// </summary>
	public class zCommentData
	{
		/// <summary>
		/// ＜summary＞で囲まれたコメント。規定値は何もなし。
		/// </summary>
		public string[] Summary = new string[0];

		/// <summary>
		/// ＜param＞で囲まれた部分。パラメータの順番に、同じ数だけ書く。規定値は何もなし。
		/// nullを入れた場合、＜param＞は作られない。
		/// </summary>
		public string[] Params = new string[0];

		/// <summary>
		/// ＜returns＞に囲まれた部分。規定値はnull。
		/// </summary>
		public string Returns = null;

		/// <summary>
		/// Paramsの数が実際と違っていた場合例外を飛ばすか。規定値はfalse。falseの場合何もしない。
		/// </summary>
		public bool ThrowException = false;
	}
}
