﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Text.RegularExpressions;

namespace aNameSpaceReplacer
{
	public class zNameSpaceReplacer
	{
		/// <summary>
		/// namespace ??? 
		/// という行をnamespace newNameSpace という行に置き換える。
		/// 行末には{があってもいい。
		/// </summary>
		public static string[] ReplaceNameSpace(IList<string> strList, string newNameSpace)
		{
			var regex = new Regex(@"^namespace [\w\.]+\s*(\{?)\s*$");

			return strList.Select(str =>
			{
				var match = regex.Match(str);

				if (match.Success)
				{
					return "namespace " + newNameSpace + match.Groups[1].Value;
				}
				else return str;
			}).ToArray();
		}
	}
}
